# ---------------------------------------------------------------------
#
# Copyright (c) CREATIS (Centre de Recherche en Acquisition et Traitement de l'Image 
#                        pour la Santé)
# Authors : Eduardo Davila, Frederic Cervenansky, Claire Mouton
#
#  This software is governed by the CeCILL-B license under French law and 
#  abiding by the rules of distribution of free software. You can  use, 
#  modify and/ or redistribute the software under the terms of the CeCILL-B 
#  license as circulated by CEA, CNRS and INRIA at the following URL 
#  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html 
#  or in the file LICENSE.txt.
#
#  As a counterpart to the access to the source code and  rights to copy,
#  modify and redistribute granted by the license, users are provided only
#  with a limited warranty  and the software's author,  the holder of the
#  economic rights,  and the successive licensors  have only  limited
#  liability. 
#
#  The fact that you are presently reading this means that you have had
#  knowledge of the CeCILL-B license and that you accept its terms.
# ------------------------------------------------------------------------  


#!/bin/bash

 echo  "in ThirdParty-install-WX.sh, source " $PWD/scripts/CreaTools-configure.sh
 if [ ! -f $PWD/scripts/CreaTools-configure.sh ]
 then 
   echo
   echo "..ERROR.."
   echo "==================================================="
   echo "REMEMBER !"
   echo ""
   echo "YOU NEED TO RUN 'Configure' (0) First !"
   echo "==================================================="
   echo
   echo
   exit 0
fi

source $PWD/scripts/CreaTools-configure.sh

   echo "------"
   echo $PWD/scripts/CreaTools-configure.sh
   echo --generationdir--
   echo $generationdir
   echo --docgeneration--
   echo $docgeneration
   echo --installPrefix--
   echo $installPrefix
   echo --installPrefixThird--
   echo $installPrefixThird
   echo --buildType--
   echo $buildType
   echo --gdcmVersion--
   echo $gdcmVersion
#   echo --sourcesFrom--
#   echo $sourcesFrom
#   echo --scriptDir--
#   echo $scriptDir
#   echo --start_point--
#   echo $start_point
   echo "------"


scriptDir=$PWD
sourcesDir=$generationdir/thirdparty_sources
binDir=$generationdir/thirdparty_bin

if [ ! -e $generationdir ]
then
   mkdir -p $generationdir
   chown -R $loginUserName  $generationdir
   chgrp -R $loginGroupName $generationdir

fi
if [ ! -e $sourcesDir ]
then
   mkdir -p $sourcesDir
   #was : (pb on MacOS?)
   #chown -R $loginUserName:$loginGroupName $sourcesDir
   chown -R $loginUserName  $sourcesDir
   chgrp -R $loginGroupName $sourcesDir
fi

if [ ! -e $binDir ]
then
   mkdir -p $binDir
   chown -R $loginUserName  $binDir
   chgrp -R $loginGroupName $binDir
fi

  echo "we remove old stuff"
  rm -rf $sourcesDir/Wx*
  rm -rf $sourcesDir/wx*
  rm -rf $binDir/Wx*

  cd $sourcesDir

 echo "we download new stuff"
 if [ $OperatingSystem = "MacOS" ]
 then
  curl -O http://biolpc22.york.ac.uk/pub/Daily_HEAD/wxWidgets.tar.gz
 tar -xvf wxWidgets.tar.gz
echo "coucou"
 fi

if [ $buildType = "Debug" ]
then
   debug="ON"
else
   debug="OFF"
fi

# the following stupid test is used at debug time; Please don't remove!
#if [ true = false ]
if [ true = true ]
then
  libname=wxWidgets
  dirInstall=$installPrefixThird/lib/wx/
  export WX_DIR=$installPrefixThird/lib/wx/
  mkdir -p $dirInstall
  echo "we prepare directories dirInstall " $dirInstall  " wx_DIR " $installPrefixThird/lib/wx/
  #cd $dirInstall

# See EED why we have to do this
  if [ $OperatingSystem = "MacOS" ]
  then
  	pwd 
    cd  $libname
    echo  "pour savoir" $libname/
    ./configure --with-osx_carbon
	make  -j $corenumber
	make install 
  fi
  cd ..
fi

